/**
*** Copyright (C) 1994 - 2002 Hewlett-Packard Company.
***
*** The information and source code contained herein is the exclusive
*** property of Hewlett-Packard Company and may not be disclosed, examined
*** or reproduced in whole or in part without explicit written authorization
*** from the company.
**/

/**
*** Author:  Geoffrey Brown 
***     based upon previous work by Paolo Faraboschi and Bill Ackerman
**/

/**
*** static char sccs_id[] = "$Id: vexopc.h,v 1.3 2003/02/19 16:18:57 frb Exp $";
**/

/**
*** Definition of VEX Opcodes
**/

#ifndef __VEX_INCLUDED__
#define __VEX_INCLUDED__

vexopc optab[] = {
/*----------------------------------------------*/
/*  as_opc            tok     flags     opctype */
/*----------------------------------------------*/
/* MEM */
  {"ldb",          (VEX_tok) OPCODE,   (VEX_flags) 0,         opLDB},
   {"ldb.d",       (VEX_tok) OPCODE,   (VEX_flags) SPEC,      opLDB},
   {"ldbu",        (VEX_tok) OPCODE,   (VEX_flags) 0,        opLDBU},
   {"ldbu.d",      (VEX_tok) OPCODE,   (VEX_flags) SPEC,     opLDBU},
   {"ldh",         (VEX_tok) OPCODE,   (VEX_flags) 0,         opLDH},
   {"ldh.d",       (VEX_tok) OPCODE,   (VEX_flags) SPEC,      opLDH},
   {"ldhu",        (VEX_tok) OPCODE,   (VEX_flags) 0,        opLDHU},
   {"ldhu.d",      (VEX_tok) OPCODE,   (VEX_flags) SPEC,     opLDHU},
   {"ldw",         (VEX_tok) OPCODE,   (VEX_flags) 0,         opLDW},
   {"ldw.d",       (VEX_tok) OPCODE,   (VEX_flags) SPEC,      opLDW},
   {"pft",         (VEX_tok) OPCODE,   (VEX_flags) 0,         opPFT},
   {"stb",         (VEX_tok) OPCODE,   (VEX_flags) 0,         opSTB},
   {"sth",         (VEX_tok) OPCODE,   (VEX_flags) 0,         opSTH},
   {"stw",         (VEX_tok) OPCODE,   (VEX_flags) 0,         opSTW},

/* STREAM  */
   {"ldb.s",       (VEX_tok) OPCODE,   (VEX_flags) STREAM,    opLDB},
   {"ldb.s.d",     (VEX_tok) OPCODE,   (VEX_flags) SSPEC,     opLDB},
   {"ldbu.s",      (VEX_tok) OPCODE,   (VEX_flags) STREAM,    opLDBU},
   {"ldbu.s.d",    (VEX_tok) OPCODE,   (VEX_flags) SSPEC,     opLDBU},
   {"ldh.s",       (VEX_tok) OPCODE,   (VEX_flags) STREAM,    opLDH},
   {"ldh.s.d",     (VEX_tok) OPCODE,   (VEX_flags) SSPEC,     opLDH},
   {"ldhu.s",      (VEX_tok) OPCODE,   (VEX_flags) STREAM,    opLDHU},
   {"ldhu.s.d",    (VEX_tok) OPCODE,   (VEX_flags) SSPEC,     opLDHU},
   {"ldw.s",       (VEX_tok) OPCODE,   (VEX_flags) STREAM,    opLDW},
   {"ldw.s.d",     (VEX_tok) OPCODE,   (VEX_flags) SSPEC,     opLDW},
   {"pft.s",       (VEX_tok) OPCODE,   (VEX_flags) STREAM,    opPFT},
   {"stb.s",       (VEX_tok) OPCODE,   (VEX_flags) STREAM,    opSTB},
   {"sth.s",       (VEX_tok) OPCODE,   (VEX_flags) STREAM,    opSTH},
   {"stw.s",       (VEX_tok) OPCODE,   (VEX_flags) STREAM,    opSTW},

/* LOCK */
   {"ldb.l",       (VEX_tok) OPCODE,   (VEX_flags) LOCK,      opLDB},
   {"ldb.l.d",     (VEX_tok) OPCODE,   (VEX_flags) LSPEC,     opLDB},
   {"ldbu.l",      (VEX_tok) OPCODE,   (VEX_flags) LOCK,      opLDBU},
   {"ldbu.l.d",    (VEX_tok) OPCODE,   (VEX_flags) LSPEC,     opLDBU},
   {"ldh.l",       (VEX_tok) OPCODE,   (VEX_flags) LOCK,      opLDH},
   {"ldh.l.d",     (VEX_tok) OPCODE,   (VEX_flags) LSPEC,     opLDH},
   {"ldhu.l",      (VEX_tok) OPCODE,   (VEX_flags) LOCK,      opLDHU},
   {"ldhu.l.d",    (VEX_tok) OPCODE,   (VEX_flags) LSPEC,     opLDHU},
   {"ldw.l",       (VEX_tok) OPCODE,   (VEX_flags) LOCK,      opLDW},
   {"ldw.l.d",     (VEX_tok) OPCODE,   (VEX_flags) LSPEC,     opLDW},
   {"pft.l",       (VEX_tok) OPCODE,   (VEX_flags) LOCK,      opPFT},
   {"stb.l",       (VEX_tok) OPCODE,   (VEX_flags) LOCK,      opSTB},
   {"sth.l",       (VEX_tok) OPCODE,   (VEX_flags) LOCK,      opSTH},
   {"stw.l",       (VEX_tok) OPCODE,   (VEX_flags) LOCK,      opSTW},

/* ALU */
   {"add",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opADD},
   {"and",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opAND},
   {"andc",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opANDC},
   {"andl",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opANDL},
   {"cmpeq",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opCMPEQ},
   {"cmpge",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opCMPGE},
   {"cmpgeu",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opCMPGEU},
   {"cmpgt",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opCMPGT},
   {"cmpgtu",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opCMPGTU},
   {"cmple",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opCMPLE},
   {"cmpleu",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opCMPLEU},
   {"cmplt",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opCMPLT},
   {"cmpltu",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opCMPLTU},
   {"cmpne",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opCMPNE},
   {"max",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opMAX },
   {"maxu",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opMAXU },
   {"min",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opMIN},
   {"minu",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opMINU},
   {"mpy",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opMUL},
   {"mpyl",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULL},
   {"mpylu",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULLU},
   {"mpyh",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULH},
   {"mpyhu",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULHU},
   {"mpyhs",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULHS},
   {"mpyll",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULLL},
   {"mpyllu",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULLLU},
   {"mpylh",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULLH},
   {"mpylhu",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULLHU},
   {"mpyhh",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULHH},
   {"mpyhhu",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opMULHHU},
   {"nandl",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opNANDL},
   {"nop",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opNOP},
   {"norl",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opNORL},
   {"or",         (VEX_tok) OPCODE,    (VEX_flags) 0,         opOR},
   {"orc",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opORC},
   {"orl",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opORL},
   {"sbit",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opSBIT},
   {"sbitf",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opSBITF},
   {"sh1add",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opSH1ADD},
   {"sh2add",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opSH2ADD},
   {"sh3add",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opSH3ADD},
   {"sh4add",     (VEX_tok) OPCODE,    (VEX_flags) 0,         opSH4ADD},
   {"shl",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opSHL},
   {"shr",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opSHR},
   {"shru",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opSHRU},
   {"slct",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opSLCT},
   {"slctf",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opSLCTF},
   {"sub",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opSUB},
   {"sxtb",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opSXTB},
   {"sxth",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opSXTH},
   {"tbit",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opTBIT},
   {"tbitf",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opTBITF},
   {"xor",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opXOR},
   {"zxtb",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opZXTB},
   {"zxth",       (VEX_tok) OPCODE,    (VEX_flags) 0,         opZXTH},

/* DIV/CARRY */
   {"divs",	  (VEX_tok) OPCODE,    (VEX_flags) 0,         opDIVS},
   {"addcg",      (VEX_tok) OPCODE,    (VEX_flags) 0,         opADDCG},

/* MOV */
   {"mov",	  (VEX_tok) OPCODE,    (VEX_flags) 0,         opMOV},
   {"mfl",	  (VEX_tok) OPCODE,    (VEX_flags) 0,         opMFL},
   {"mtl",	  (VEX_tok) OPCODE,    (VEX_flags) 0,         opMTL},
   {"mfb",	  (VEX_tok) OPCODE,    (VEX_flags) 0,         opMFB},
   {"mtb",	  (VEX_tok) OPCODE,    (VEX_flags) 0,         opMTB},
   {"mtbf",	  (VEX_tok) OPCODE,    (VEX_flags) 0,         opMTBINV},

/* BRANCH */
   {"goto",       (VEX_tok) OPCODE,    (VEX_flags) CTLFLOW,   opGOTO},
   {"call",       (VEX_tok) OPCODE,    (VEX_flags) CTLFLOW,   opCALL},
   {"return",     (VEX_tok) OPCODE,    (VEX_flags) CTLFLOW,   opRETURN},
   {"br",         (VEX_tok) OPCODE,    (VEX_flags) CTLFLOW,   opBRANCH},
   {"brf",        (VEX_tok) OPCODE,    (VEX_flags) CTLFLOW,   opBRANCHF},

/* ASM */
   {"asm",        (VEX_tok) OPCODE,    (VEX_flags) 0,         opASM},

/* XNOP */
   {"xnop",       (VEX_tok) XNOP,      (VEX_flags) 0,         opXNOP},

/**************** PSEUDO  (VEX_tok) OPCODES *************************/

   {".call",      (VEX_tok) _CALL_JMP,  (VEX_flags) 0,        opCALLDIR},
   {".longjmp",   (VEX_tok) _CALL_JMP,  (VEX_flags) 0,        opLONGJMPDIR},
   {"._longjmp",  (VEX_tok) _CALL_JMP,  (VEX_flags) 0,        opLONGJMPDIR},
   {".__longjmp", (VEX_tok) _CALL_JMP,  (VEX_flags) 0,        opLONGJMPDIR},
   {".setjmp",    (VEX_tok) _CALL_JMP,  (VEX_flags) 0,        opSETJMPDIR},
   {"._setjmp",   (VEX_tok) _CALL_JMP,  (VEX_flags) 0,        opSETJMPDIR},
   {".__setjmp",  (VEX_tok) _CALL_JMP,  (VEX_flags) 0,        opSETJMPDIR},

/*************  ASSEMBLER DIRECTIVES **********************/

   {".align",      (VEX_tok) _ALIGN,    (VEX_flags) 0,         opASMDIR},
   {".ascii",      (VEX_tok) _ASCII,    (VEX_flags) 0,         opASMDIR},
   {".bss",        (VEX_tok) _BSS,      (VEX_flags) 0,         opASMDIR},
   {".section",    (VEX_tok) _SECTION,  (VEX_flags) 0,         opASMDIR},
   {".comment",    (VEX_tok) _COMMENT,  (VEX_flags) 0,         opASMDIR},
   {".comm",       (VEX_tok) _COMMON,   (VEX_flags) 0,         opASMDIR},
   {".data",       (VEX_tok) _DATA,     (VEX_flags) 0,         opASMDIR},
   {".data1",      (VEX_tok) _DATA1,    (VEX_flags) 0,         opASMDIR},
   {".data2",      (VEX_tok) _DATA2,    (VEX_flags) 0,         opASMDIR},
   {".data4",      (VEX_tok) _DATA4,    (VEX_flags) 0,         opASMDIR},
   {".endp",       (VEX_tok) _ENDP,     (VEX_flags) 0,         opASMDIR},
   {".entry",      (VEX_tok) _ENTRY,    (VEX_flags) 0,         opASMDIR},
   {".equ",        (VEX_tok) _EQU,      (VEX_flags) 0,         opASMDIR},
   {".import",     (VEX_tok) _IMPORT,   (VEX_flags) 0,         opASMDIR},
   {".proc",       (VEX_tok) _PROC,     (VEX_flags) 0,         opASMDIR},
   {".real4",      (VEX_tok) _REAL4,    (VEX_flags) 0,         opASMDIR},
   {".real8",      (VEX_tok) _REAL8,    (VEX_flags) 0,         opASMDIR},
   {".return",     (VEX_tok) _RETURN,   (VEX_flags) 0,         opASMDIR},
   {".rta",        (VEX_tok) _RTA,      (VEX_flags) 0,         opASMDIR},
   {".skip",       (VEX_tok) _SKIP,     (VEX_flags) 0,         opASMDIR},
   {".sversion",   (VEX_tok) _SVERSION, (VEX_flags) 0,         opASMDIR},
   {".text",       (VEX_tok) _TEXT,     (VEX_flags) 0,         opASMDIR},
   {".trace",      (VEX_tok) _TRACE,    (VEX_flags) 0,         opASMDIR},
   {".type",       (VEX_tok) _TYPE,     (VEX_flags) 0,         opASMDIR},

   {NULL}
};

#endif

